/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.syn.services.jms

import com.persagy.base.extensions.toJson
import com.persagy.database.SFilter
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.datacenter.datacenter.models.entities.dictnew.DefClass
import com.persagy.server.datacenter.models.entities.dictnew.DictProject
import com.persagy.server.datacenter.wanda.obj.Project
import com.persagy.server.syn.Configure
import com.persagy.server.syn.jms.MessageReceiver
import com.persagy.server.syn.jms.bean.SyncRwdDatacenterMessage
import com.persagy.server.syn.models.api.obj.BuildingApi
import com.persagy.server.syn.models.tools.ProjectUtil
import com.persagy.server.syn.services.dict.DClassDefService
import com.persagy.server.syn.task.SyncTaskDict
import com.persagy.service.SBaseService
import com.persagy.service.SObjectService
import org.slf4j.LoggerFactory
import org.springframework.stereotype.Service
import java.util.concurrent.Executors

/**
 * 数据中台 - 项目
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/11/2 22:48
 */
@Service
class RwdProject {
    companion object {
        // 日志
        private val logger = LoggerFactory.getLogger(MessageReceiver::class.java)
    } // Companion object
    /** 项目服务 */
    private val projectService = SBaseService(SMybatisDao(Project::class.java))
    /** 缓存对象数据 - 数据中台到数据中心 */
    var syncRwdMessageService = SObjectService(SMybatisDao(SyncRwdDatacenterMessage::class.java))
    /** 项目所属的集团 */
    private val dictProjectService = SObjectService(SMybatisDao(DictProject::class.java))
    /** 字典平台对象类型 */
    private val defClassService = SBaseService(SMybatisDao(DefClass::class.java))

    /** 创建线程池  */
    val executorService = Executors.newFixedThreadPool(15)

    /**
     * 项目
     */
    fun projectType(message: SyncRwdDatacenterMessage) {
        logger.debug("消息 = ${message.toJson()}")
        when(message.type){
            Configure.RWDCREATE -> {
                /** 集团数据 */
                DClassDefService.groupQuerys()
                /** 集团和项目的关系 */
                DClassDefService.dictProject()

                DClassDefService.dictProjectType(message.projectId!!)
                DClassDefService.dictProjectInfo(message.projectId!!)
                /** 创建 */
                val dictProject = dictProjectService.select(SFilter.eq("id", message.projectId!!)).entity()
                if (dictProject!=null) {
                    dictProject(dictProject.groupCode!!,message.targetId!!)
                    val queryIdList = BuildingApi.queryId(dictProject.groupCode!!, message.projectId!!, message.targetId!!)
                    if (queryIdList.size>0){
                        val buildingDataConversions = ProjectUtil.projectDataConversions(
                            dictProject!!.groupCode!!,
                            queryIdList[0]
                        )
                        projectService.replace(buildingDataConversions)
                        message.state = 0

                    } else {
                        message.count+1
                        message.state = 2
                    }

                } else {
                    message.state = 2
                    message.count =message.count +1
                }
                /** 更改标记 */
                syncRwdMessageService.update(message, arrayListOf("state","count"))
            }
            Configure.RWDUPDATE -> {

                val entity = projectService.select(SFilter.eq("id", message.projectId!!)).entity()
                logger.debug("消息11 = ${entity?.toJson()}")
                if (entity!=null){
                    /** 修改 */
                    val dictProject = dictProjectService.select(SFilter.eq("id", message.projectId!!)).entity()
                    if (dictProject!=null) {
                        val queryIdList = BuildingApi.queryId(dictProject.groupCode!!, message.projectId!!, message.targetId!!)
                        if (queryIdList.size>0){
                            val buildingDataConversions =  ProjectUtil.projectDataConversions(
                                    dictProject!!.groupCode!!,
                                    queryIdList[0]
                            )
                            projectService.replace(buildingDataConversions)
                            message.state = 0
                        } else {
                            message.state = 2
                            message.count+1
                        }
                    } else {
                        message.state = 2
                        message.count+1
                    }
                    /** 更改标记 */
                    syncRwdMessageService.update(message, arrayListOf("state","count"))
                }
            }
            Configure.RWDDELETE -> {
                /** 删除 */
//                val delete = projectService.delete(
//                    SFilter.eq("id", message.targetId!!)
//                )
//                if (delete) {
//                    message.state = 0
//                } else {
//                    message.state = 2
//                }
//                /** 更改标记 */
//                syncRwdMessageService.update(message, arrayListOf("state"))
            }
        }
    }

    /**
     * 项目字典
     *
     * @param groupCode     集团编码
     */
    fun dictProject(groupCode: String,projectId:String){
        /** 项目字典的类型 */
        DClassDefService.dictProjectTypeId(projectId)
        val defClassList = defClassService.select(SFilter.eq("projectId", projectId)).exec()
        for (defClass in defClassList) {
            executorService.execute(SyncTaskDict(groupCode,projectId,defClass.code!!))
        }
    }
}